/*
maketable.cc
by Andreas Balser
Published under the GNU Public License
*/

// Nur zwei-ziffrige Punktewerte zulaessig!
// besser keine Umlaute ...

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <iostream.h>
//#include <iostream>
//#include <sstream>
using namespace std;

#define PREAMBLE "\\documentclass[]{article}\n\\pagestyle{empty}\n\\addtolength{\\oddsidemargin}{-1.5in}\n\\addtolength{\\evensidemargin}{-1.5in}\n\\textheight 25cm\n\\addtolength{\\topmargin}{-1in}\n\\addtolength{\\textwidth}{6cm}\n\\begin{document}\n\\subsection*{\\center{"

#define ABSENCESTRING "--"
#define ABSENCECHAR '-'
#define EXCUSEDSTRING "e"
#define EXCUSEDCHAR 'e'

#define ERROR   -1
#define ABSENT  -2
#define EXCUSED -3


#define BUF_SIZE 100

FILE * input;
FILE * output;

int students;
bool average;

char* IntToStr (char* buf, int number){
  if(number==0) {
    buf[0]='0';
    buf[1]=0;
    return buf;
  }
  int copy = number;
  
  int digits=0;
  while(copy > 0) {copy /= 10; digits++;}
  buf[digits] = 0;
  for (int i=0; i<digits; i++){
    copy = number % 10;
    number = number/10;
    buf[digits-1-i] = copy + '0';
  }
  return buf;
}

int StrToInt (char* buf){
  if ((buf[0]<'0' || buf[0]>'9')&&buf[0] != ABSENCECHAR&&buf[0]!=EXCUSEDCHAR)
    {
    return ERROR;
}  
  int returnV=0;
  if(buf[0]==ABSENCECHAR){
    return ABSENT;
  }
  if(buf[0]==EXCUSEDCHAR) return EXCUSED;
  while(*buf >='0' && *buf <='9') {
    returnV*=10;
    returnV+=(*buf)-'0';
    buf++;
  }
  return returnV;
}

int computeAverage(int total, int* maxima, int* studresults, int discard){
  double result = 0;
  int res;
  if (total==0) return 0;
  double interres[total];

  for(int i=0; i<total; i++){
    if (studresults[i]>0){
      
      interres[i]=(average)? ((double)(studresults[i]*100)/ maxima[i]) 
	                   : studresults[i];
      result += interres[i];
      }
    else {
      interres[i] = 0;
      if(studresults[i] == EXCUSED && average) discard++;
    }
  }
  double worstresults[discard];

  // Do we have to check for worst results?
  if(discard > 0) {
    int i, j;
    double im1, im2;
    for (i=0; i<discard; i++) worstresults [i] = 100;
    // in this way, we don't have to worry about the beginning of the process.
    // let's use insertion sort
    for (i=0; i<total; i++) {
      if(interres[i]> worstresults[0]) continue;
      for (j=1; j<discard && interres[i] < worstresults[j]; j++) ;
      im1 = interres[i];
      for (j-- ; j >= 0; j--) {
	im2 = worstresults[j];
	worstresults[j] = im1;
	im1=im2;
      }
    }

    for(j=0; j < discard; j++){
      result -= worstresults[j];
    }

  }
  if(average){
    res = (int) ((result/(total-discard))+.5);
    if(res > 100) return 100;
  }
  else
    res=(int)result;

  return res;
}

//this adds a space IN FRONT OF the character at pos.
void add_space (long* length, long pos, char* theFile){
  long mov;
  for (mov = (*length)+1; mov >= pos; mov--)
    theFile[mov+1] = theFile[mov];
  (*length)++;
  theFile[*length] = 0;
  theFile[pos] = ' ';
}

//this adds an ABSENCECHAR  IN FRONT OF the character at pos.
void add_abs (long* length, long pos, char* theFile){
  long mov;
  for (mov = (*length)+1; mov >= pos; mov--)
    theFile[mov+1] = theFile[mov];
  (*length)++;
  theFile[*length] = 0;
  theFile[pos] = ABSENCECHAR;
}

//this removes space after the character at pos.
void remove_spaces (long* length, long pos, char* theFile, int howmany){
  long mov;
  for (mov=pos; 
                  theFile[mov]!=' ' && 
	          theFile[mov]!='\t' && 
	          theFile[mov] != '\n' && 
	             theFile[mov]!=0; mov++);
  if(theFile[mov]!='\n') theFile[mov]=theFile[mov+howmany];
  (*length)-=howmany;
  for (mov++; mov <= (*length); mov++)
    theFile[mov] = theFile[mov+howmany];
  theFile[*length] = 0;
}

void adjust_input(char* filename){
  FILE* inp;
  bool changed=false;
  long length, origLength;
  //  printf("%s\n", filename);
   if((inp=fopen(filename, "r"))==NULL) {
    printf("Could not open specified file!\n");
    exit(1);
  }
  fseek(inp, 0, SEEK_END);
  length=ftell(inp);
  origLength = length;
  rewind(inp);

  char theFile [length+1000];
  fread(theFile, sizeof(char), length, inp);
  fclose(inp);
  theFile[length] = 0;

  long i=0;
  i=0;
  // skip the first lines (?)

  while(theFile[i] != '\n') i++;
  if(theFile[i-1] != ' ' && theFile[i-1]!='\t' && theFile[i-1] != '\n') {
    add_space(&length, i, theFile);
    i++;
    changed=true;
  }
  i++;
  int k;
  long mov;
  students=0;

  while(i<length-2) {
    students++;
    // first step over the line with the names.
    int j=0;
    for(;theFile[i]!= '\n'; i++,j++);

    if(j<=1){
      printf("Empty Name-line!\n");
      exit(1);
    }
    while(theFile[i-1] ==' ' || theFile[i-1] == '\t') {
      i--;
      remove_spaces(&length, i, theFile, 1);
      changed = true;
    }
    i++;

    while (theFile[i] != '\n' && theFile[i] != 0) {
      k=0;

      while (theFile[i] == ' ' || theFile[i]=='\t' || theFile[i]<0) {i++; k++; }
      while ((theFile[i] >= '0' && theFile[i] <= '9') || 
	     theFile[i] == ABSENCECHAR || theFile[i] == EXCUSEDCHAR) {
	i++; k++;
      }
      if(theFile[i]!= 0 && theFile[i]!= ' ' && 
	 theFile[i] != '\t' && theFile[i] != '\n'){
	int prob = (unsigned char) theFile[i];
	printf("%d\n", prob);
	printf("bad input!\n%s\n",&(theFile[i]));
	exit(1);
      }
	
      if (k<2){
	add_space(&length, i-k, theFile);
	i++;
	changed=true;
      }
      else if(k>2) {
	remove_spaces(&length, i-k, theFile,k-2);
	i+=2-k;
	changed=true;
      }
      if(theFile[i] == ' '||theFile[i]=='\t') i++;
    }
    if((theFile[i] == '\n' || theFile[i] ==0) && theFile[i-1] != '\n') 
      if(theFile[i-1] != ' ' && theFile[i-1] != '\t') {
      add_space(&length, i, theFile);
      i++;
      changed=true;
      }
      else while(theFile[i-2] ==' ' || theFile[i-2] == '\t') {
	i--;
	remove_spaces(&length, i, theFile, 1);
	changed = true;
      }

    i++;    
  }
  for (i=0; i<length; i++)
    if(theFile[i] == '\t' || theFile[i]<0){
      theFile[i] = ' ';
      changed=true;
    }
  if(changed){
    if((inp=fopen(filename, "w"))==NULL) {
      printf("Could not open specified file!\n");
      exit(1);
    }
    fwrite(theFile, sizeof(char), strlen(theFile), inp);
    fclose(inp);
  }
}

int add_absentchar(char** absents, int absent, char* filename){
  FILE* inp;
  long length, origLength;
   if((inp=fopen(filename, "r"))==NULL) {
    printf("Could not open specified file!\n");
    exit(1);
  }
  fseek(inp, 0, SEEK_END);
  length=ftell(inp);
  origLength = length;
  rewind(inp);

  char theFile [length+1000];
  fread(theFile, sizeof(char), length, inp);
  fclose(inp);
  theFile[length] = 0;
  long i=0;
  int j,k;
  for( k=0; k < absent; i++){
    j=0;
    while(theFile[i] == absents[k][j] && theFile[i]!='\n') {
      i++; j++;
    }
    if(theFile[i]=='\n') {
      k++;
      // add absenceChar
      i++;
      while(theFile[i] != '\n') i++;
      add_abs(&length, i, theFile);
      i++;
    }
    else
      while(theFile[i]!='\n') i++;
  }

  if((inp=fopen(filename, "w"))==NULL) {
    printf("Could not open specified file!\n");
    exit(1);
  }
  fwrite(theFile, sizeof(char), strlen(theFile), inp);
  fclose(inp);
}

int main (int nargs, char** args){
  char buffer[BUF_SIZE];
  char filename[BUF_SIZE];
  char numbuf[BUF_SIZE];
  char buf2[BUF_SIZE];
  char bufName[BUF_SIZE];
  int totalnumber=0;
  int columns=0;
  int discard = 0;
  int i;
  //  FILE*pre;
  average=true;

  if (nargs < 2) {
    printf("Usage: maketable filename (without .tab) [-p] [DiscardNumbers] [TotalNumberOfColumns]\n");
    exit(1);
  }
  int startsAt=0;
  if(nargs>2){
    if(args[2][0]=='-'){
      if(args[2][1]=='p')
	average = false;
      startsAt++;
    }
  }

  strcpy(buffer, args[1]);
  strcat(buffer, ".tab");

  strcpy(filename, buffer);
  adjust_input(filename);

  if((input=fopen(buffer, "r"))==NULL) {
    printf("Could not open specified file!\n");
    exit(1);
  }
  
  strcpy(buffer, args[1]);
  strcat(buffer, ".tex");
  if((output=fopen(buffer, "w"))==NULL) {
    printf("Could not open output-file!");
    exit(1);
  }

  fwrite(PREAMBLE, sizeof(char), strlen(PREAMBLE), output);

  // read input (spaltenzahl ud max.werte)

  fgets(buffer, BUF_SIZE, input);
  fwrite(buffer,sizeof(char), strlen(buffer),output);
  fgets(buf2, BUF_SIZE,input);
  fgets(buffer, BUF_SIZE,input);
  for(i=0; buffer[i]!=0; i++){
    if(buffer[i]>='0' && buffer[i] <='9'){
      totalnumber++;
      while(buffer[i]>='0' && buffer[i] <='9') i++;
    }
  }


  if (nargs-startsAt>2) {
    if (nargs-startsAt > 3) {
      columns=StrToInt(args[startsAt+3]) - totalnumber;
      discard=StrToInt(args[startsAt+2]);
    }
    else {
      int intermediate = StrToInt(args[startsAt+2]);
      if(intermediate < totalnumber) discard = intermediate;
      else columns = intermediate - totalnumber;
    }
  }
  if(!average) discard=0;
  if (columns < 0) columns = 0;
  int maxima[(totalnumber > 0) ? totalnumber: 1];
  int studresults[totalnumber > 0 ? totalnumber: 1];
  int attendance[(totalnumber > 0) ? totalnumber: 1];
	int avscore[(totalnumber > 0 ) ? totalnumber: 1];
  
  char* var=buffer;
  i=0;

  while(*var!=0) {
    maxima[i]=StrToInt(var);
    attendance[i]=0;
	avscore[i]=0;
    while(*var >='0' && *var <='9') var++;
    if(*var!=0) var++;
    i++;
  }
  int totalsum = 0;
  for(i=0; i<totalnumber; i++)
    totalsum+= maxima[i];

  
  strcpy(buffer, "}}\n\\center{number of discarded results: ");
  strcat(buffer, IntToStr(numbuf, discard));
  fwrite(buffer,sizeof(char), strlen(buffer),output);

  strcpy(buffer, "}\n\\medbreak\n\\begin{tabular}{@{}|l@{ }||r||");
  fwrite(buffer,sizeof(char), strlen(buffer),output);
  buffer[0]=0;

  for(i=0; i<totalnumber+columns; i++) strcat(buffer,"c|");
  fwrite(buffer,sizeof(char), strlen(buffer),output);
  buffer[0]=0;
  if(average) strcat(buffer,"@{}}\n\\hline\n &Av");
  else strcat(buffer,"@{}}\n\\hline\n &$\\Sigma$");
  fwrite(buffer,sizeof(char), strlen(buffer),output);
  buffer[0]=0;
  for(i=1; i<=totalnumber+columns; i++) {
    strcat(buffer, "&");
    strcat(buffer, IntToStr(numbuf, i));
  }
  fwrite(buffer,sizeof(char), strlen(buffer),output);
  strcpy(buffer,"\\\\\n\\hline\n");

  strcat(buffer,buf2);
  if(average) strcat(buffer, "&100\\%");
  else {
    strcat(buffer, "&");
    strcat(buffer, IntToStr(numbuf,totalsum));
  }
  fwrite(buffer,sizeof(char), strlen(buffer),output);
  buffer[0]=0;
  for(i=0; i<totalnumber; i++){
    strcat(buffer, "&");
    strcat(buffer, IntToStr(numbuf, maxima[i]));
  }
  for(i=0; i<columns; i++){
    strcat(buffer, "& ");
  }
  strcat(buffer,"\\\\\n\\hline\\hline\n");

  fwrite(buffer,sizeof(char), strlen(buffer),output);
  

  int percentage;
  long cur = ftell(input);
  fseek(input, 0, SEEK_END);
  long  length=ftell(input);
  fseek(input, cur, SEEK_SET);

  // get students' data (and write it)
  int count=0;
  char* absents [students];
  for (i=0; i<students; i++)
    absents[i] = new char [BUF_SIZE];
  int absentnumber = 0 ;
  long averagepercentage=0;
  while (ftell(input)<length){
    count++;
    if(count%50==0){
      strcpy(buffer, "\\end{tabular}\n");
      fwrite(buffer, sizeof(char),strlen(buffer),output);

      strcpy(buffer, "\n\\medbreak\n\\begin{tabular}{@{}|l@{ }||r||");
      fwrite(buffer,sizeof(char), strlen(buffer),output);
      buffer[0]=0;

      for(i=0; i<totalnumber+columns; i++) strcat(buffer,"c|");
      fwrite(buffer,sizeof(char), strlen(buffer),output);
      buffer[0] = 0;
      strcat(buffer,"@{}}\n\\hline\n &Av");
      fwrite(buffer,sizeof(char), strlen(buffer),output);
      buffer[0] = 0;
      for(i=1; i<=totalnumber+columns; i++) {
	strcat(buffer, "&");
	strcat(buffer, IntToStr(numbuf, i));
      }
      fwrite(buffer,sizeof(char), strlen(buffer),output);
      strcpy(buffer,"\\\\\n\\hline\n");
      
      if(average) strcat(buffer, "&100\\%");
      else {
	strcat(buffer, "&");
	strcat(buffer, IntToStr(numbuf,totalsum));
      }
      fwrite(buffer,sizeof(char), strlen(buffer),output);
      buffer[0] = 0;
      for(i=0; i<totalnumber; i++){
	strcat(buffer, "&");
	strcat(buffer, IntToStr(numbuf, maxima[i]));
      }
      for(i=0; i<columns; i++){
	strcat(buffer, "& ");
      }
      strcat(buffer,"\\\\\n\\hline\\hline\n");
      
      fwrite(buffer,sizeof(char), strlen(buffer),output);
      
      
      
    }
    //    get one student's data
    fgets(bufName,BUF_SIZE, input);
    fgets(buffer,BUF_SIZE, input);
    var=buffer;

    for (i=0;i<totalnumber; i++){
      while(*var==' ' || *var=='\t') var++;
      studresults[i] = StrToInt(var);
      if(studresults[i] == ERROR){
	if(i != totalnumber - 1){
	  cout<<"There is a problem in the input file-line corresponding to"<<endl;
	  cout<<bufName;
	  exit(1);
	}
	else {
	  strcpy (absents[absentnumber], bufName);
	  absentnumber++;
	  cout<<"absent: " <<bufName;
	}
      }
      while(*var==EXCUSEDCHAR || *var==ABSENCECHAR||
	    (*var >='0' && *var <='9')) var++;
      if(*var!=0) var++;
    }
    if(strlen(var) > 1) {
	cout<<"There is something wrong in the input file-line corresponding to"<<endl;
	cout<<bufName;
	exit(1);
      }
    // write it
    percentage = computeAverage(totalnumber, maxima, studresults, discard);
    averagepercentage += percentage;
    strcpy(buf2, "& ");
    strcat(buf2, IntToStr(numbuf, percentage));
    cout<<percentage<<"\t"<<bufName;
    if(average) strcat(buf2, "\\%");
    fwrite(bufName, sizeof(char),strlen(bufName),output);
    fwrite(buf2, sizeof(char),strlen(buf2),output);

    for(i=0; i<totalnumber; i++){
      if(studresults[i]>=0) {
	attendance[i]++;
	avscore[i]+=studresults[i];
	}
      strcpy(buf2, "& ");
      if(studresults[i]==ABSENT){
	strcat(buf2, ABSENCESTRING);
      }
      else
	if(studresults[i] == EXCUSED)
	  strcat(buf2, EXCUSEDSTRING);
	else
	  strcat(buf2, IntToStr(numbuf, studresults[i])); 
	
      fwrite(buf2, sizeof(char),strlen(buf2),output);
    }
    buf2[0]=0;
    for(i=0; i<columns; i++)
      strcat(buf2, "& ");

    strcat(buf2, "\\\\\n\\hline\n");
    fwrite(buf2, sizeof(char), strlen(buf2),output);
  }

  strcpy(buffer, "\\hline\nAttendance&");
  for(i=0; i<totalnumber; i++) {
    strcat(buffer, "& ");
    strcat(buffer, IntToStr(numbuf, attendance[i]));
  }
  for(i=0; i<columns; i++)
    strcat(buffer, "& ");
  strcat(buffer, "\\\\\n\\hline\n");
  fwrite(buffer,sizeof(char), strlen(buffer),output);
  strcpy(buffer, "Average");
  if(average) strcat(buffer, " percentage&");
  else strcat(buffer, "&");
  strcat(buffer, IntToStr(numbuf,(int((double) 
				      averagepercentage / count)))); 
  if(average) strcat(buffer, "\\%");
  for(i=0; i<totalnumber; i++){
    strcat(buffer, "& ");
    strcat(buffer, IntToStr(numbuf,
			    (int)((double)((long)avscore[i]*100)/(attendance[i]*maxima[i])+.5))); 
  }
  for(i=0; i<columns; i++) strcat(buffer, "& ");
  strcat(buffer, "\\\\\n\\hline\n");
  fwrite(buffer,sizeof(char), strlen(buffer),output);

  strcpy(buffer, "\\end{tabular}\n\\end{document}\n");
  fwrite(buffer, sizeof(char),strlen(buffer),output);

  if(
     fclose(output) != 0) printf("Mist");

  if(absentnumber>0){
    cout<<"add ABSENCECHARs for absent people? (y/n)"<<endl;
    scanf("%s",buffer);
    if(buffer[0]=='y') {
      add_absentchar(absents, absentnumber, filename);
      main(nargs, args);
    }
  }

  exit(0);
}


